<?php
$default_ip = '172.16.0.0';
$default_cidr = '12';
?><!DOCTYPE html>
<html lang="fr">
<head>
<title>TSRIT-TRTE | IPv4</title>
<meta charset="UTF-8" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" href="/style/crm.css" />
<link rel="stylesheet" href="/style/crm-960.css" />
</head>
<body>

<header>
<h1><a href="/">TSRIT-TRTE.CRM</a></h1>
<img src="../style/im/ipv4.png" alt="" />
<h2><a href="ipcalc.php">Calculateur IPv4</a></h2>
</header>




<section>
<div>
<form method="post" action="<?php echo $_SERVER['PHP_SELF'] ?>">
IP &amp; Masque ou CIDR : <input type="text" name="my_net_info" value="<?php echo isset($_POST['my_net_info']) ? $_POST['my_net_info'] : $default_ip.'/'.$default_cidr; ?>" size="31" maxlength="32"> 
 &nbsp; <input type="submit" value="Valider" name="subnetcalc">
</form>
</div>
</section>


<?php
// end of table
$end='<div class="clear"></div></div>'."\n".'</section>
<aside>
<div><h3>Exemples</h3><p>IP + CIDR : 172.16.0.1/16</p><p>IP + Masque : 172.16.0.1 255.255.0.0</p><p>IP + Joker: 172.16.0.1 0.0.255.255</p></div>
</aside>
</body>
</html>';

echo '<section><div>';
if (empty($_POST['my_net_info'])){
	$_POST['my_net_info'] = $default_ip.'/'.$default_cidr;
	/*echo '<p>Entrez une valeur</p>';
	echo $end;
	exit ;*/
}

$my_net_info=rtrim($_POST['my_net_info']);



if (! ereg('^([0-9]{1,3}\.){3}[0-9]{1,3}(( ([0-9]{1,3}\.){3}[0-9]{1,3})|(/[0-9]{1,2}))$',$my_net_info)){
	echo '<p>Entrée non valide</p>';
	echo $end;
	exit ;
}

if (ereg("/",$my_net_info)){  //if cidr type mask
	$dq_host = strtok("$my_net_info", "/");
	$cdr_nmask = strtok("/");
	if (!($cdr_nmask >= 0 && $cdr_nmask <= 32)){
		echo "<p>CIDR invalide. (0 - 32)</p>";
		echo $end;
		exit ;
	}
	$bin_nmask=cdrtobin($cdr_nmask);
	$bin_wmask=binnmtowm($bin_nmask);
} else { //Dotted quad mask?
    $dqs=explode(" ", $my_net_info);
	$dq_host=$dqs[0];
	$bin_nmask=dqtobin($dqs[1]);
	$bin_wmask=binnmtowm($bin_nmask);
	if (ereg("0",rtrim($bin_nmask, "0"))) {  //Wildcard mask then? hmm?
		$bin_wmask=dqtobin($dqs[1]);
		$bin_nmask=binwmtonm($bin_wmask);
		if (ereg("0",rtrim($bin_nmask, "0"))){ //If it's not wcard, whussup?
			echo "<p>Masque invalide</p>";
			echo $end;
			exit ;
		}
	}
	$cdr_nmask=bintocdr($bin_nmask);
}

//Check for valid $dq_host
if(! ereg('^0.',$dq_host)){
	foreach( explode(".",$dq_host) as $octet ){
 		if($octet > 255){ 
			echo "<p>IP non valide</p>";
			echo $end;
			exit;
		}
	
	}
}

$bin_host=dqtobin($dq_host);
$bin_bcast=(str_pad(substr($bin_host,0,$cdr_nmask),32,1));
$bin_net=(str_pad(substr($bin_host,0,$cdr_nmask),32,0));
$bin_first=(str_pad(substr($bin_net,0,31),32,1));
$bin_last=(str_pad(substr($bin_bcast,0,31),32,0));
$host_total=(bindec(str_pad("",(32-$cdr_nmask),1)) - 1);

if ($host_total <= 0){  //Takes care of 31 and 32 bit masks.
	$bin_first="N/A" ; $bin_last="N/A" ; $host_total="N/A";
	if ($bin_net === $bin_bcast) $bin_bcast="N/A";
}
$special = 'Réseau IP public';
//Determine Class
if (ereg('^0',$bin_net)){
	$class="A";
	$dotbin_net= "<font color=\"Green\">0</font>" . substr(dotbin($bin_net,$cdr_nmask),1) ;

}elseif (ereg('^10',$bin_net)){
	$class="B";
	$dotbin_net= "<font color=\"Green\">10</font>" . substr(dotbin($bin_net,$cdr_nmask),2) ;
}elseif (ereg('^110',$bin_net)){
  	$class="C";
	$dotbin_net= "<font color=\"Green\">110</font>" . substr(dotbin($bin_net,$cdr_nmask),3) ;
}elseif (ereg('^1110',$bin_net)){
  	$class="D";
	$dotbin_net= "<font color=\"Green\">1110</font>" . substr(dotbin($bin_net,$cdr_nmask),4) ;
	$special="Classe D = Réservé Diffusion";
}else{
  	$class="E";
	$dotbin_net= "<font color=\"Green\">1111</font>" . substr(dotbin($bin_net,$cdr_nmask),4) ;
	$special="Classe E = Expérimental";
}

if (ereg('^(00001010)|(101011000001)|(1100000010101000)',$bin_net)){
  	 $special='Réseau IP local';
}

// Print Results
echo '<p class="res">Adresse</p><p class="res2">'.$dq_host.'</p>';
echo '<p class="res3 end">'.dotbin($bin_host,$cdr_nmask).'</p>'."\n";

echo '<p class="res">Masque</p><p class="res2">'.bintodq($bin_nmask).' &nbsp; /'.$cdr_nmask.'</p>';
echo '<p class="res3 red">'.dotbin($bin_nmask, $cdr_nmask).'</p>'."\n";

echo '<p class="res">Joker</p><p class="res2">'.bintodq($bin_wmask).'</p>';
echo '<p class="res3">'.dotbin($bin_wmask, $cdr_nmask).'</p>'."\n";

echo '<p class="res">Réseau</p><p class="res2">'.bintodq($bin_net).'</p>';
echo '<p class="res3">'.$dotbin_net.'</p><p class="res4">Class '.$class.'</p>'."\n";

echo '<p class="res">Broadcast</p><p class="res2">'.bintodq($bin_bcast).'</p>';
echo '<p class="res3">'.dotbin($bin_bcast, $cdr_nmask).'</p>'."\n";

echo '<p class="res">1er hôte</p><p class="res2">'.bintodq($bin_first).'</p>';
echo '<p class="res3">'.dotbin($bin_first, $cdr_nmask).'</p>'."\n";

echo '<p class="res">Dernier hôte</p><p class="res2">'.bintodq($bin_last).'</p>';
echo '<p class="res3">'.dotbin($bin_last, $cdr_nmask).'</p>'."\n";

echo '<p class="res">Hôtes/réseau</p><p class="res2">'.$host_total.'</p>';
echo '<p class="res3 green">'.$special.'</p>'."\n";

echo $end;

?>

<?php

function binnmtowm($binin){
	$binin=rtrim($binin, "0");
	if (!ereg("0",$binin) ){
		return str_pad(str_replace("1","0",$binin), 32, "1");
	} else return "1010101010101010101010101010101010101010";
}

function bintocdr ($binin){
	return strlen(rtrim($binin,"0"));
}

function bintodq ($binin) {
	if ($binin=="N/A") return $binin;
	$binin=explode(".", chunk_split($binin,8,"."));
	for ($i=0; $i<4 ; $i++) {
		$dq[$i]=bindec($binin[$i]);
	}
        return implode(".",$dq) ;
}

function bintoint ($binin){
        return bindec($binin);
}

function binwmtonm($binin){
	$binin=rtrim($binin, "1");
	if (!ereg("1",$binin)){
		return str_pad(str_replace("0","1",$binin), 32, "0");
	} else return "1010101010101010101010101010101010101010";
}

function cdrtobin ($cdrin){
	return str_pad(str_pad("", $cdrin, "1"), 32, "0");
}

function dotbin($binin,$cdr_nmask){
	// splits 32 bit bin into dotted bin octets
	if ($binin=="N/A") return $binin;
	$oct=rtrim(chunk_split($binin,8,"."),".");
	if ($cdr_nmask > 0){
		$offset=sprintf("%u",$cdr_nmask/8) + $cdr_nmask ;
		return substr($oct,0,$offset ) . "&nbsp;&nbsp;&nbsp;" . substr($oct,$offset) ;
	} else {
	return $oct;
	}
}

function dqtobin($dqin) {
        $dq = explode(".",$dqin);
        for ($i=0; $i<4 ; $i++) {
           $bin[$i]=str_pad(decbin($dq[$i]), 8, "0", STR_PAD_LEFT);
        }
        return implode("",$bin);
}

function inttobin ($intin) {
        return str_pad(decbin($intin), 32, "0", STR_PAD_LEFT);
}

function tr(){
	echo "\t<tr>";
	for($i=0; $i<func_num_args(); $i++) echo "<td>".func_get_arg($i)."</td>";
	echo "</tr>\n";
}
?>