<?php
/* PHP IFB.LIB 0.4.x beta $ 2012/05/12 
 * Copyright Mickael Devoldere, All Rights Reserved
 * License: http://www.gnu.org/licenses/gpl-3.0.txt
 * $Id: ifb.cache.php $ Mike - CRM edition 04/2013
*/

if(!defined('IFB'))
	exit('[01] Fatal Error');

class ifbCache
{
	
const cPHP = '.php';
const cDAT = '.dat';
protected $cache;
protected $data, $save = array();
protected $cacheExpire = 43200; // 43200 = 12h

public function __construct($subDir = NULL)
{
	$this->cache = IFB.'cache/'.(isset($subDir) ? $subDir.'/' : NULL);
}

public function cacheLevel($lvl)
{
	$this->cacheLevel = (int)$lvl;
}
public function cacheExpire($sec)
{
	$this->cacheExpire = (int)$sec;
	$this->cacheLevel = ($this->cacheExpire > 0) ? $this->cacheLevel : 0;
}

// public loadFiles( mixed $files, [int $dataType = NULL] )
public function getFile($f)
{
	if(!is_array($f))
	{
		$ftestTmp = $this->getArray($f);
		$ftest = isset($ftestTmp) ? 1 : $this->getContent($f);
		return  isset($ftest) ? $this->data[$f] : NULL;
	}

	foreach($f as $file)
	{
		$ftestTmp = $this->getArray($file);
		if(!isset($ftestTmp))
			$this->getContent($file);
	}
	return;
}

public function getVar($var, $f)
{
	return isset($this->data[$f][$var]) ? $this->data[$f][$var] : NULL;
}
public function getData($f)
{
	return isset($this->data[$f]) ? $this->data[$f] : NULL;
}

// public setData 
public function setData($var, $f)
{
	if(is_array($var))
		$this->save['php'][] = $f;
	else
		$this->save['dat'][] = $f;

	$this->data[$f] = $var;
}

public function saveFiles()
{
	$saved = '';
	if(isset($this->save['php']))
	{
		foreach($this->save['php'] as $f) 
		{ 
			$saved .= $this->saveArray($f).' ';
		}
	}
	if(isset($this->save['dat']))
	{
		foreach($this->save['dat'] as $f) 
		{ 
			$saved .= $this->saveContent($f).' ';
		}
	}
	$this->save = array();
	return 'cacheSaved: '.$saved;
}


/********** PRIVATE FUNCTIONS **********/

protected function getArray($f)
{
	$ftime = $this->checkFile($f.self::cPHP);
	if(isset($ftime))
	{
		$f = $this->cleanVar($f);
		require $this->cache.$f.self::cPHP;
		$this->data[$f] = $$f;
		return $ftime;
	}
	return;
}
protected function saveArray($f)
{
	file_put_contents($this->cache.$f.self::cPHP, '<?php '."\n".'$'.$this->cleanVar($f).' = '.var_export($this->data[$f], true).'; '."\n".'?>');
	return $f.self::cPHP;
}

protected function getContent($f)
{
	$ftime = $this->checkFile($f.self::cDAT);
	if(isset($ftime))
	{
		$this->data[$f] = file_get_contents($this->cache.$f.self::cDAT);
		return $ftime;
	}
	return;
}
protected function saveContent($f)
{
	file_put_contents($this->cache.$f.self::cDAT, $this->data[$f]);
	return $f.self::cDAT;
}


// protected checkFile( string $fileName )
protected function checkFile($f)
{
	if(!file_exists($this->cache.$f))
		return;
	$f = filemtime($this->cache.$f);
	$expire = $_SERVER['REQUEST_TIME'] - $this->cacheExpire;
	return ($f > $expire ? ($f-$expire) : 1);
}

protected function getExt($file)
{
  return substr(strtolower(strrchr(basename($file), ".")), 1);
}

// protected stringToVar ( string $var )
protected function cleanVar($var)
{
	return 'c'.preg_replace("/[^a-zA-Z0-9_]/","_", $var);
}

public function cleanName($var)
{
	return preg_replace("/[^a-zA-Z0-9._]/","_", $var);
}


} // class end
// preg_match('/a:[0-9]+:\{[aisb]+:(.*?)\}/', $file)
?>