<? 
/* PHP IFB.LIB 0.4.x beta $ 2013/04/12 
 * Copyright Mickael Devoldere, All Rights Reserved
 * License: http://www.gnu.org/licenses/gpl-3.0.txt
 * $Id: ifb.ip4.php $ Mike - CRM edition 04/2013
*/

/********** IFB IPv4 NETWORKING CLASS **********/
class ifb4ip // extends ifbCache
{

const IP4 = '172.16.0.0'; // default IP (check function getIp4())
const CIDR = '16'; // default cidr
const MASK = '255.255.0.0'; // default mask

public $cidr = array
(
1 => '128.0.0.0',
2 => '192.0.0.0',
3 => '224.0.0.0',
4 => '240.0.0.0',
5 => '248.0.0.0',
6 => '252.0.0.0',
7 => '254.0.0.0',
8 => '255.0.0.0', // A
9 => '255.128.0.0',
10 => '255.192.0.0',
11 => '255.224.0.0',
12 => '255.240.0.0', //
13 => '255.248.0.0',
14 => '255.252.0.0',
15 => '255.254.0.0',
16 => '255.255.0.0', // B default mask
17 => '255.255.128.0',
18 => '255.255.192.0',
19 => '255.255.224.0',
20 => '255.255.240.0',
21 => '255.255.248.0',
22 => '255.255.252.0',
23 => '255.255.254.0',
24 => '255.255.255.0', // C
25 => '255.255.255.128',
26 => '255.255.255.192',
27 => '255.255.255.224',
28 => '255.255.255.240',
29 => '255.255.255.248',
30 => '255.255.255.252',
);

protected $ip = array
(
'dec' 			=> '', // 172.16.2.1
'dec2' => array(0 => '', 1 => '', 2 => '', 3 => '', ),

'bin' 			=> '', // 10101100.00010000.00000010.00000001
'bin2' => array(0 => '', 1 => '', 2 => '', 3 => '', ),

'cidr' 			=> '', // 12
'mask' 			=> '', // 255.240.0.0
'mask_bin'		=> '', // 11111111.11110000.00000000.00000000

'netid'	 		=> '', // 10101100.0001
'hostid' 		=> '', // 0000.00000010.00000001

);


private $init, $vars, $loops = array();

public function __construct($ip4=self::IP4, $cidr=self::CIDR)
{
	$this->getIp4($ip4, $cidr);
}

public function getNetwork()
{
	// $cidr = $this->getCidr($cidr);
	
	return var_export($this->ip, true);

}

public function getIp4($ip4=self::IP4, $cidr=self::CIDR)
{
	// $ip4 = filter_var($ip4, FILTER_VALIDATE_IP) ? $ip4 : self::IP4;
	$ip4 = explode('.',$ip4);

	$this->ip['dec2'][3] = isset($ip4[3]) ? intval($ip4[3]) : 0;
	$this->ip['dec2'][2] = isset($ip4[2]) ? intval($ip4[2]) : 0;
	$this->ip['dec2'][1] = isset($ip4[1]) ? intval($ip4[1]) : 16;
	$ip4[0] = intval($ip4[0]);
	$this->ip['dec2'][0] = ($ip4[0] >= 0) ? $ip4[0] : 172;

	$this->ip['dec'] = implode('.', $this->ip['dec2']);

	foreach($this->ip['dec2'] as $k => $v)
	{
		$this->ip['bin2'][$k] = str_pad(decbin($v), 8, 0, STR_PAD_LEFT);
	}
	
	$this->ip['bin'] = implode('.', $this->ip['bin2']);
	
	$this->getCidr($cidr);
	
	return $this->ip['dec'];
}

public function getCidr($cidr) // ie 16 (no slash)
{
	$this->ip['cidr'] = intval($cidr);
	$this->ip['cidr'] = array_key_exists($this->ip['cidr'], $this->cidr) ? $this->ip['cidr'] : self::CIDR;
	$this->ip['mask'] = $this->cidr[$this->ip['cidr']];
	
	$maskTmp = explode('.', $this->ip['mask']);

	$this->ip['mask_bin'] = '';
	foreach($maskTmp as $k => $v)
	{
		$this->ip['mask_bin'] .= str_pad(decbin($v), 8, 0, STR_PAD_LEFT).'.';
	}
	$this->ip['mask_bin'] = substr($this->ip['mask_bin'], 0, -1);

	return $this->ip['cidr'];
}

public function getMask($mask) // ie 255.255.0.0
{
	$mask = filter_var($mask, FILTER_VALIDATE_IP) ? $mask : self::MASK;
	return in_array($mask, $this->cidr) ? $mask : $this->cidr[self::CIDR];
}

public function getIp($var)
{
	return isset($this->ip[$var]) ? $this->ip[$var] : NULL;
}



public function setBin($dec)
{
	return decbin(intval($dec));
}
public function setBinDot($bin) // separate bytes with dot
{
	return substr(chunk_split($bin, 8, '.'), 0, -1);
}

public function setDec($bin)
{
	return bindec(intval($bin));
}

public function setHex($bin)
{
	return binhex(intval($bin));
}

} // fin classe
?>