<? 
/* PHP IFB.LIB 0.4.x beta $ 2012/05/12 
 * Copyright Mickael Devoldere, All Rights Reserved
 * License: http://www.gnu.org/licenses/gpl-3.0.txt
 * $Id: ifb.tpl.php $ Mike - CRM edition 04/2013
*/

/********** IFB TEMPLATE CLASS **********/
class ifbTemplate extends ifbCache
{
	
const tplEXT = '.html'; // template files extension

private $tpl, $tplDir, $tplCache, $tplCacheFile;
private $files, $vars, $loops = array();

public function __construct($body)
{
	parent::__construct('html');
	$this->tplDir = IFBL.'templates/'; // CRM edition
	$this->tpl = $body;
	$this->tplCache = 0;
}

public function setTplCache($f) // 0 or 1
{
	$this->tplCache = (int)$f;
}

public function setTpl($key, $f) // {{KEY}}, fileName
{
	$this->files[$key] = $f;
	if($key == 'CONTENT')
		$this->tplCacheFile = $f;
}
public function setTplVar($key, $var) // {{KEY}}, varName
{
	$this->vars[0][] = '{{'.$key.'}}';
	$this->vars[1][] = $var;
}
public function setTplVars($evars)
{
	foreach($evars as $key => $var)
	{
		$this->vars[0][] = '{{'.$key.'}}';
		$this->vars[1][] = $var;
	}
}
public function setLoop($loop, $vars) // <!-- {{LOOP_KEY}} -->, (array)vars
{
	$this->loops[$loop] = $vars;
}

public function display()
{
	if($this->tplCache === 1)
	{
		if($this->getContent($this->tplCacheFile) > 2)
		{
			$this->tpl = $this->data[$this->tplCacheFile];
		}
		else
		{
			$this->parseHtml();
			$this->setData($this->tpl, $this->tplCacheFile);
			$this->saveContent($this->tplCacheFile);
		}
	}
	else
	{
		$this->parseHtml();
	}

	$this->parseData();
	return $this->tpl;
}


/********** PRIVATE FUNCTIONS **********/

private function parseHtml()
{
	$this->tpl = $this->getTpl($this->tpl);

	if(count($this->files) > 0)
	{
		foreach($this->files as $k => $f)
		{
			$this->tpl = str_replace('{{'.$k.'}}', $this->getTpl($f), $this->tpl);
		}
	}
	return;
}

private function parseData()
{
	if(count($this->loops) > 0)
	{
		foreach($this->loops as $loopName => $loop)
		{
			$loop_src = $this->getLoop($loopName);
			$loop_result = '';
			foreach($this->loops[$loopName] as $current => $vars)
			{
				$loop_tmp = $loop_src;
				foreach($this->loops[$loopName][$current] as $key => $var)
				{
					$loop_tmp = str_replace('{{'.$key.'}}', $var, $loop_tmp);
				}
				$loop_result .= $loop_tmp;
			}
			$this->tpl = str_replace($loop_src, $loop_result, $this->tpl);
			$this->tpl = str_replace('<!-- {loop:'.$loopName.'} -->', '', $this->tpl);
			$this->tpl = str_replace('<!-- {/loop:'.$loopName.'} -->', '', $this->tpl);
		}
	}
	
	if(!in_array('{{CONTENT_HEADER}}', $this->vars[0]))
	{
		$this->vars[0][] = '{{CONTENT_HEADER}}';
		$this->vars[1][] = '';
	}
	if(!in_array('{{CONTENT_FOOTER}}', $this->vars[0]))
	{
		$this->vars[0][] = '{{CONTENT_FOOTER}}';
		$this->vars[1][] = '';
	}
	if(!in_array('{{THEMES}}', $this->vars[0]))
	{
		$this->vars[0][] = '{{THEMES}}';
		$this->vars[1][] = '';
	}
	$this->tpl = str_replace($this->vars[0], $this->vars[1], $this->tpl);
	return;
}

private function getTpl($f)
{
	return file_exists($this->tplDir.$f.self::tplEXT) ? file_get_contents($this->tplDir.$f.self::tplEXT) : NULL;
}
private function getLoop($name)
{
	$Start = "<!-- {loop:".$name."} -->";
	$End = "<!-- {/loop:".$name."} -->";
	$debut = strpos($this->tpl, $Start); // + strlen($Start)
	$fin = strpos($this->tpl, $End);
	$result = substr($this->tpl, $debut, $fin-$debut);
	return $result;
}

} // fin classe
?>